﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Microsoft.HomeServer.Extensibility;
using System.Reflection;

namespace Microsoft.HomeServer.HomeServerConsoleTab.DuplicationInfo
{
    public class HomeServerTabExtender : IConsoleTab
    {
        private UserControl panel;
        private IConsoleServices services;

        public HomeServerTabExtender(int width, int height, IConsoleServices services)
        {
            try
            {
                this.panel = new ShowDuplicationInfoPanel();
                this.panel.Size = new Size(width, height);

                this.services = services;
            }
            catch (Exception ex)
            {
                this.panel = new ErrorReportPanel(ex);
            }
        }

        public bool GetHelp() { return false; }

        public string TabText { get { return "Duplication Info"; } }
        public Bitmap TabImage { get { return Properties.Resources.DuplicationInfoImage; } }
        public Control TabControl { get { return this.panel; } }

        public Guid SettingsGuid { get { return Guid.Empty; } }
    }
}
